import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { HouseViewsLog, HouseViewsLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询看房记录表
 */
export async function pageHouseViewsLog(params: HouseViewsLogParam) {
  const res = await request.get<ApiResult<PageResult<HouseViewsLog>>>(
    MODULES_API_URL + '/house/house-views-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询看房记录表列表
 */
export async function listHouseViewsLog(params?: HouseViewsLogParam) {
  const res = await request.get<ApiResult<HouseViewsLog[]>>(
    MODULES_API_URL + '/house/house-views-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加看房记录表
 */
export async function addHouseViewsLog(data: HouseViewsLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-views-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改看房记录表
 */
export async function updateHouseViewsLog(data: HouseViewsLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-views-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除看房记录表
 */
export async function removeHouseViewsLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-views-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除看房记录表
 */
export async function removeBatchHouseViewsLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-views-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询看房记录表
 */
export async function getHouseViewsLog(id: number) {
  const res = await request.get<ApiResult<HouseViewsLog>>(
    MODULES_API_URL + '/house/house-views-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
